/* ===============================================
  OPEN CLOSE Menu
============================================= */

function career_counseling_open_menu() {
  jQuery('button.menu-toggle').addClass('close-panal');
  setTimeout(function(){
    jQuery('nav#main-menu').show();
  }, 100);

  return false;
}
jQuery( "button.menu-toggle").on("click", career_counseling_open_menu);

function career_counseling_close_menu() {
  jQuery('button.close-menu').removeClass('close-panal');
  jQuery('nav#main-menu').hide();
}

jQuery( "button.close-menu").on("click", career_counseling_close_menu);

/* ===============================================
  TRAP TAB FOCUS ON MODAL MENU
============================================= */

jQuery('button.close-menu').on('keydown', function (e) {
  if (jQuery("this:focus") && !!e.shiftKey && e.keyCode === 9) {
  } else if (jQuery("this:focus") && (e.which === 9)) {
    e.preventDefault();
    jQuery(this).blur();
    jQuery('.menu li a:first').focus()
  }
});

jQuery('.menu li a:first').on('keydown', function (event) {
  if (jQuery("this:focus") && !!event.shiftKey && event.keyCode === 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('button.close-menu').focus()
  }
});

jQuery('#main-menu ul:first li:first a').on('keydown', function (event) {
  if (event.shiftKey && event.keyCode == 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('button.close-menu').focus();
  }
})

jQuery(document).ready(function() {
  window.addEventListener('load', (event) => {
      jQuery(".loader").delay(2000).fadeOut("slow");
  });
})

/* ===============================================
  Scroll Top //
============================================= */

jQuery(window).scroll(function () {
  if (jQuery(this).scrollTop() > 100) {
      jQuery('.scroll-up').fadeIn();
  } else {
      jQuery('.scroll-up').fadeOut();
  }
});

jQuery('a[href="#tobottom"]').click(function () {
  jQuery('html, body').animate({scrollTop: 0}, 'slow');
  return false;
});

(function ($) {
  $(window).scroll(function () {
    var sticky = $('.sticky-header'),
      scroll = $(window).scrollTop();

    if (scroll >= 100) sticky.addClass('fixed-header');
    else sticky.removeClass('fixed-header');
  });
})(jQuery);

/* ===============================================
  Custom Cursor
============================================= */

const career_counseling_customCursor = {
  init: function () {
    this.career_counseling_customCursor();
  },
  isVariableDefined: function (el) {
    return typeof el !== "undefined" && el !== null;
  },
  select: function (selectors) {
    return document.querySelector(selectors);
  },
  selectAll: function (selectors) {
    return document.querySelectorAll(selectors);
  },
  career_counseling_customCursor: function () {
    const career_counseling_cursorDot = this.select(".cursor-point");
    const career_counseling_cursorOutline = this.select(".cursor-point-outline");
    if (this.isVariableDefined(career_counseling_cursorDot) && this.isVariableDefined(career_counseling_cursorOutline)) {
      const cursor = {
        delay: 8,
        _x: 0,
        _y: 0,
        endX: window.innerWidth / 2,
        endY: window.innerHeight / 2,
        cursorVisible: true,
        cursorEnlarged: false,
        $dot: career_counseling_cursorDot,
        $outline: career_counseling_cursorOutline,

        init: function () {
          this.dotSize = this.$dot.offsetWidth;
          this.outlineSize = this.$outline.offsetWidth;
          this.setupEventListeners();
          this.animateDotOutline();
        },

        updateCursor: function (e) {
          this.cursorVisible = true;
          this.toggleCursorVisibility();
          this.endX = e.clientX;
          this.endY = e.clientY;
          this.$dot.style.top = `${this.endY}px`;
          this.$dot.style.left = `${this.endX}px`;
        },

        setupEventListeners: function () {
          window.addEventListener("load", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          career_counseling_customCursor.selectAll("a, button").forEach((el) => {
            el.addEventListener("mouseover", () => {
              this.cursorEnlarged = true;
              this.toggleCursorSize();
            });
            el.addEventListener("mouseout", () => {
              this.cursorEnlarged = false;
              this.toggleCursorSize();
            });
          });

          document.addEventListener("mousedown", () => {
            this.cursorEnlarged = true;
            this.toggleCursorSize();
          });
          document.addEventListener("mouseup", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          document.addEventListener("mousemove", (e) => {
            this.updateCursor(e);
          });

          document.addEventListener("mouseenter", () => {
            this.cursorVisible = true;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          });

          document.addEventListener("mouseleave", () => {
            this.cursorVisible = false;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          });
        },

        animateDotOutline: function () {
          this._x += (this.endX - this._x) / this.delay;
          this._y += (this.endY - this._y) / this.delay;
          this.$outline.style.top = `${this._y}px`;
          this.$outline.style.left = `${this._x}px`;

          requestAnimationFrame(this.animateDotOutline.bind(this));
        },

        toggleCursorSize: function () {
          if (this.cursorEnlarged) {
            this.$dot.style.transform = "translate(-50%, -50%) scale(0.75)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1.6)";
          } else {
            this.$dot.style.transform = "translate(-50%, -50%) scale(1)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1)";
          }
        },

        toggleCursorVisibility: function () {
          if (this.cursorVisible) {
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          } else {
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          }
        },
      };
      cursor.init();
    }
  },
};
career_counseling_customCursor.init();

/* ===============================================
  Progress Bar
============================================= */
const career_counseling_progressBar = {
  init: function () {
      let career_counseling_progressBarDiv = document.getElementById("elemento-progress-bar");

      if (career_counseling_progressBarDiv) {
          let career_counseling_body = document.body;
          let career_counseling_rootElement = document.documentElement;

          window.addEventListener("scroll", function (event) {
              let career_counseling_winScroll = career_counseling_body.scrollTop || career_counseling_rootElement.scrollTop;
              let career_counseling_height =
              career_counseling_rootElement.scrollHeight - career_counseling_rootElement.clientHeight;
              let career_counseling_scrolled = (career_counseling_winScroll / career_counseling_height) * 100;
              career_counseling_progressBarDiv.style.width = career_counseling_scrolled + "%";
          });
      }
  },
};
career_counseling_progressBar.init();

/* ===============================================
   sticky copyright
============================================= */

window.addEventListener('scroll', function() {
  var career_counseling_footer = document.querySelector('.sticky-copyright');
  if (!career_counseling_footer) return; 

  var career_counseling_scrollTop = window.scrollY || document.documentElement.career_counseling_scrollTop;

  if (career_counseling_scrollTop >= 100) {
    career_counseling_footer.classList.add('active-sticky');
  }
});

/* ===============================================
   sticky sidebar
============================================= */

window.addEventListener('scroll', function () {
  var career_counseling_sidebar = document.querySelector('.sidebar-sticky');
  if (!career_counseling_sidebar) return;

  var career_counseling_scrollTop = window.scrollY || document.documentElement.scrollTop;
  var career_counseling_windowHeight = window.innerHeight;
  var career_counseling_documentHeight = document.documentElement.scrollHeight;

  var career_counseling_isBottom = career_counseling_scrollTop + career_counseling_windowHeight >= career_counseling_documentHeight - 100;

  if (career_counseling_scrollTop >= 100 && !career_counseling_isBottom) {
    career_counseling_sidebar.classList.add('sidebar-fixed');
  } else {
    career_counseling_sidebar.classList.remove('sidebar-fixed');
  }
});